<?php
use rp\Cache;
use rp\Url;
use rp\Config;
use rp\Db;
use rp\index\LogsMod;

/*
*导航
*/
function navs(){
	$nav=Cache::read('nav');
	$category=Cache::read('category');
	foreach($nav as $k=>$v){
		$newtab = $v['newtab'] == 1 ? 'target="_blank"' : '';
		echo '<li '.((!empty($v['children']) || ($v['types'] == 2 && !empty($category[$v['typeId']]['children']))) ? 'class="menu"' : '').'><a href="'.$v['url'].'" '.$newtab.'>'.$v['navname'].'</a>';
		if(!empty($v['children'])){
			echo '<ul class="sub">';
			foreach($v['children'] as $sk=>$sv){
				$newtab2 = $sv['newtab'] == 1 ? 'target="_blank"' : '';
				echo '<li><a href="'.$sv['url'].'" '.$newtab2.'>'.$sv['navname'].'</a></li>';
			}
			echo '</ul>';
		}
		if($v['types'] == 2 && !empty($category[$v['typeId']]['children'])){
			echo '<ul class="sub">';
			foreach($category[$v['typeId']]['children'] as $ck=>$cv){
				$data=$category[$cv];
				$url=Url::cate($cv);
				$newtab3 = $v['newtab'] == 1 ? 'target="_blank"' : '';
				echo '<li><a href="'.$url.'" '.$newtab3.'>'.$data['cate_name'].'</a></li>';
			}
			echo '</ul>';
		}
		echo'</li>';
	}
}

/*文章分类*/
function category(){
	$category=Cache::read('category');
	foreach($category as $k=>$v){
		$category[$k]['url']=Url::cate($v['id']);
	}
	return $category;
}

/*文章归档*/
function record(){
	$logRecord=Cache::read('logRecord');
	foreach($logRecord as $k=>$v){
		$logRecord[$k]['url']=Url::other('date',$v['date']);
	}
	return $logRecord;
}

/*友情链接*/
function links(){
	$links=Cache::read('links');
	$linksHtml='<ul class="links">';
	foreach($links as $k=>$v){
		$linksHtml.='<li><a href="'.$v['siteurl'].'" target="_blank" title="'.$v['sitedesc'].'">'.$v['sitename'].'</a></li>';
	}
	return $linksHtml.'</ul>';
}

/*面包屑导航*/
function mianbao($type,$value){
	global $App;
	$html='<a href="'.$App->baseUrl.'" title="返回首页">首页</a>&nbsp;&gt;&nbsp;';
	switch($type){
		case 'search':
			$html.='搜索&nbsp;<b>&nbsp;'.$value.'&nbsp;</b>&nbsp;的结果';
			break;
		case 'tages':
			$tages=Cache::read('tages');
			if(isset($tages[$value])){
				$html.='<a href="'.Url::other('tages',$value).'">'.$tages[$value]['tagName'].' 的文章</a>';
			}
			break;
		case 'logs':
			$html.='<a href="'.$value['cateUrl'].'">'.$value['cateName'].'</a>&nbsp;&gt;&nbsp;正文';
			break;
		case 'author':
			$user=Cache::read('user');
			if(isset($user[$value])){
				$html.='<a href="'.Url::other('author',$value).'">'.$user[$value]['nickname'].' 的文章</a>';
			}
			break;
		case 'cate':
			$category=Cache::read('category');
			if(isset($category[$value])){
				$html.='<a href="'.Url::cate($value).'">'.$category[$value]['cate_name'].'</a>';
			}
			break;
		case 'special':
			$special=Cache::read('special');
			if(isset($special[$value])){
				$html.='<a href="'.Url::special($value).'">'.$special[$value]['title'].'</a>';
			}
			break;
		case 'page':
			$pages=Cache::read('pages');
			if(isset($pages[$value])){
				$html.='<a href="'.Url::page($value).'">'.$pages[$value]['title'].'</a>';
			}
			break;
		case 'date':
			$html.='<a href="'.Url::other('date',$value).'">'.$value.'</a>';
			break;
			
	}
	return $html;
}

/*评论列表*/
function comment_list($CommentData){
	$html='<h3 class="comment_title">有 <b>'.$CommentData['count'].'</b> 位网友评论：</h3><div class="comment_list">';
	$comments=$CommentData['list'];
	$commentsData=$comments['lists'];
	foreach($comments['top'] as $k=>$v){
		$comment = $commentsData[$v];
		$html.= '<div class="comment_msg" data-id="'.$comment['id'].'"><img class="comment_avatar" src="'.getHead($comment['email']).'"/>
			<div class="comment_content">
				<p class="comment_name">
					<a href="'.(!empty($comment['home']) ? $comment['home'] : 'javascript:;').'" rel="nofollow" target="_blank">'.$comment['nickname'].'</a>
					<span class="comment_time"><i class="iconfont icon-time"></i> '.formatDate($comment['createTime']).'</span>
					<button type="button" class="quickReplay"><i class="iconfont icon-comment"></i>回复</button>
				</p>
				<p class="comment_info"><i class="iconfont"></i>'.$comment['content'].'</p>
			</div>';
		$html.=comment_list_children($comment['children'],$commentsData);
		$html.='</div>';
	}
	return $html.'</div><div class="pages comment_page">'.$CommentData['pageHtml'].'</div>';
}
/*子评论列表*/
function comment_list_children($children,$commentsData){
	$html='';
	if(!empty($children)){
		foreach($children as $k=>$v){
			$comment = $commentsData[$v];
			$html.='<div class="comment_msg comment_msg_son" data-id="'.$comment['id'].'"><img class="comment_avatar" src="'.getHead($comment['email']).'"/>
				<div class="comment_content">
					<p class="comment_name">
						<a href="'.(!empty($comment['home']) ? $comment['home'] : 'javascript:;').'" rel="nofollow" target="_blank">'.$comment['nickname'].'</a>
						<span class="comment_time"><i class="iconfont icon-time"></i> '.formatDate($comment['createTime']).'</span>
						<button type="button" class="quickReplay"><i class="iconfont icon-comment"></i>回复</button>
					</p>
					<p class="comment_info"><i class="iconfont"></i>'.$comment['content'].'</p>
				</div>';
				$html.=comment_list_children($comment['children'],$commentsData);
			$html.='</div>';
		}
	}
	return $html;
}
/*发表评论*/
function comment_post($types,$id,$user,$isRemark){
	$types = $types == 'pages' ? 'pages' : 'logs';
	$id=intval($id);
	$html='<p style="padding: 3rem;text-align: center;">评论功能暂时关闭</p>';
	if(Config::get('webConfig.commentStatus') == 1 && $isRemark == 1){
		$html='<form id="commentSumbit" target="_self" method="post" action="/comment/addcom" class="form_box" onSubmit="return false;">
			<input type="hidden" name="types" id="types" value="'.$types.'">
			<input type="hidden" name="vid" id="vid" value="'.$id.'">
			<input type="hidden" name="topId" id="topId" value="0">
			<div class="input_line"><input type="text" name="username" id="username" value="'.$user['nickname'].'" tabindex="1" placeholder="名称(*)"></div>
			<div class="input_line"><input type="text" name="email" id="email" tabindex="2" value="'.$user['email'].'" placeholder="邮箱"></div>
			<div class="input_line"><input type="text" name="home" id="home" tabindex="3" value="'.$user['home'].'" placeholder="主页网站http(s)://"></div>';
		Config::get('webConfig.commentVcode') == 1 && $html.='<div class="input_line input_qrcode" style="padding-right: 0;"><input type="text" name="verifyCode" id="verifyCode" tabindex="4" placeholder="验证码(*)"><img id="commentVcode" src="'.Url::other('captcha','comment').'" alt="请填写验证码" onclick="javascript:this.src=this.src+\'?v=\'+new Date().getTime();"></div>';
		$html.='<div class="input_textarea">
				<textarea name="content" id="content" cols="50" rows="4" tabindex="5" placeholder="欢迎你的交流和评论，还请不要无意义的灌水呢(°ー°〃)"></textarea>
				<input name="sumbit" type="submit" tabindex="6" value="提交评论" onclick="return commentPost()" class="form_btn">
			</div>
		</form>';
	}
	return $html;
}

function getHead($email){
	$headImg=TEMPURL .'/images/avatar.gif';
	if(empty($email)){
		return $headImg;
	}
	$emailArr=explode('@', $email,2);
	if($emailArr[1] == 'qq.com' && is_numeric($emailArr[0])){
		$headImg='http://q1.qlogo.cn/g?b=qq&nk='.$emailArr[0].'&s=100&t='. time();
	}else{
		$hash = md5($email);
		$s=45;
		$d='mm';
		$g='g';
		$avatar = 'http://secure.gravatar.com/avatar/'.$hash.'?s='.$s.'&d='.$d.'&r='.$g;
		$headImg=!empty($avatar) ? $avatar : '';
	}
	return $headImg;
}


/*正文中匹配缩略图*/
function thumb($data,$len=1){
	preg_match_all("|<img[^>]+src=\"([^>\"]+)\"?[^>]*>|is", $data['content'], $img);
	$thumb=array();
	if(isset($img[1]) && !empty($img[1])){
		$max=min(count($img[1]),$len);
		for($i=0;$i<$max;$i++){
			$imgs=$img[1][$i];
			$newimg=dirname($imgs). '/thum-' .basename($imgs);
			$thumb[]='<img src="'.(file_exists(CMSPATH .'/'. $newimg) ? $newimg : $imgs).'" alt="'.$data['title'].'"/>';
		}
	}else{
		$thumb[]= '<img src="'. TEMPURL .'/images/random/'.rand(1,20).'.jpg" alt="'.$data['title'].'"/>';
	}
	return join('',$thumb);
}

/****以下为新增常用功能函数****/

/*
*最新文章
*@param $limit int 数量
*/
function newLogs($limit=10){
	$LogsMod=new LogsMod();
	$logData=$LogsMod->limit($limit)->order(['a.id'=>'desc'])->select();
	return $logData['list'];
}
 
/*
*置顶文章
*@param $limit int 数量
*/
function topLogs($limit=10){
	$LogsMod=new LogsMod();
	$logData=$LogsMod->limit($limit)->where(['a.isTop'=>1])->select();
	return $logData['list'];
}
 
/*
*热门文章
*@param $limit int 数量
*/
function hotLogs($limit=10){
	$LogsMod=new LogsMod();
	$logData=$LogsMod->limit($limit)->order(['a.views'=>'desc'])->select();
	return $logData['list'];
}
 
/*
*热评文章
*@param $limit int 数量
*/
function commentLogs($limit=10){
	$LogsMod=new LogsMod();
	$logData=$LogsMod->limit($limit)->order(['a.comnum'=>'desc'])->select();
	return $logData['list'];
}
 
/*
*点赞文章
*@param $limit int 数量
*/
function upLog($limit=10){
	$LogsMod=new LogsMod();
	$logData=$LogsMod->limit($limit)->order(['upnum'=>'desc'])->select();
	return $logData['list'];
}
 
/*
*随机文章
*@param $limit int 数量
*/
function randLog($limit=10){
	$LogsMod=new LogsMod();
	$dbConfig=Config::get('db');
	$obj=Db::instance()->query('SELECT IF((SELECT MAX(id) FROM '.$dbConfig['prefix'].'logs) >= '.$limit.', ROUND(RAND() * ((SELECT MAX(id) FROM '.$dbConfig['prefix'].'logs)-(SELECT MIN(id) FROM '.$dbConfig['prefix'].'logs)-'.$limit.'))  , 0) as startId');
	$id=$obj->result();
	$logData=$LogsMod->limit($limit)->where(['a.id'=>['>',$id['startId']]])->select();
	return $logData['list'];
}
 
/*
*相邻文章
*@param $logId int 文章ID
*/
function neighbor($logId){
	$LogsMod=new LogsMod();
	$res=$LogsMod->neighbor($logId);
	$prev='上一篇：没有了 ';
	$next='下一篇：没有了 ';
	if(!empty($res['prev'])){
		$prev='上一篇：'.$res['prev']['title'].'';
	}
	if(!empty($res['next'])){
		$next='下一篇：'.$res['next']['title'].'';
	}
	return $prev.$next;
}
 
/*
*相关文章
*@param $data array 内容页的文章数据
*@param $type string 相关类型，catr or tages
*@param $limit int 数量
*/
function related($data, $type='cate', $limit=10){
	$LogsMod=new LogsMod();
	$list=$LogsMod->related($data,$type,$limit);
	return $list;
}

/*
*获取指定栏目(分类)的文章
*@param $id int 分类ID
*@param $limit int 数量
*@param $order array 排序方式
*/
function getListByCate($id, $limit=10, $order=['a.upateTime'=>'desc','a.id'=>'desc']){
	if(empty($id)) return [];
	$LogsMod=new LogsMod();
	$ids=[$id];
	$category=Cache::read('category');
	if(!empty($category[$id]['children'])){
		$ids=array_merge($ids,$category[$id]['children']);
	}
	$logData=$LogsMod->cate($ids)->order($order)->limit($limit)->select();
	return $logData['list'];
}
 
/*
*获取指定单页内容
*@param $id int 单页ID
*@param $len int 内容长度，0获取全部
*/
function getPageContent($id, $len=0){
	$data=Db::name('pages')->where(['id'=>intval($id)])->field('content')->find();
	return !empty($data) ? ($len > 0 ? getContentByLength($data['content'],$len) : $data['content']) : '';
}
 
/*
*获取指定栏目的子栏目（html）
*@param $id int 分类ID
*/
function getChildByCate_html($id){
	$category=Cache::read('category');
	$cate=isset($category[$id]) ? $category[$id] : [];
	echo '<li>全部</li>';
	if(!empty($cate['children'])){
		foreach($cate['children'] as $k=>$v){
			$data=$category[$v];
			echo '<li>'.$data['cate_name'].'</li>';
		}
	}
}
 
/*
*获取指定栏目的子栏目（array）
*@param $id int 分类ID
*/
function getChildByCate_array($id){
	$category=Cache::read('category');
	if(isset($category[$id])){
		$cateArr=[];
		foreach($category[$id]['children'] as $k=>&$v){
			$cateArr[]=[
				'id'=>$v,
				'url'=>Url::cate($v),
				'cate_name'=>$category[$v]['cate_name'],
			];
		}
		return $cateArr;
	}
	return [];
}
 
/*
*获取指定导航的子导航（array）
*@param $type string 导航类型，cate:分类,page:单页,diy:自定义
*@param $id int 导航ID
*/
function getChildByNav($type,$id){
	$nav=Cache::read('nav');
	$navId='';
	$subList=[];
	$typeId=['diy'=>1,'cate'=>2,'page'=>3];
	if(!isset($typeId[$type])) return $subList;
	foreach($nav as $k=>$v){
		if($typeId[$type] == $v['types'] && $id == $v['typeId']){
			$navId=$v['id'];break;
		}
		if(!empty($v['children'])){
			foreach($v['children'] as $sk=>$sv){
				if($typeId[$type] == $sv['types'] && $id == $sv['typeId']){
					$navId=$sv['topId'];break 2;
				}
			}
		}
	}
	if(!empty($nav[$navId]['children'])){
		$subList=$nav[$navId]['children'];
	}
	return $subList;
}

/*
*获取分类信息
*@param $id int 分类ID
*/
function getDataByCate($id){
	$category=Cache::read('category');
	if(isset($category[$id])){
		return $category[$id];
	}
	return [];
}
 
/*
*获取作者信息
*@param $id int 作者ID
*/
function getDataByAuthor($id){
	$user=Cache::read('user');
	return isset($user[$id]) ? $user[$id] :  [];
}
 
/*
*获取分类名称&Url（html）
*@param $id int 分类ID
*/
function getHtmlByCate($id){
	$category=Cache::read('category');
	if(isset($category[$id])){
		echo ''.$category[$id]['cate_name'].'';
	}else{
		echo '未知栏目';
	}
}
 
/*
*获取单页名称&Url（html）
*@param $id int 单页ID
*/
function getHtmlByPage($id){
	$pages=Cache::read('pages');
	if(isset($pages[$id])){
		echo ''.$pages[$id]['title'].'';
	}else{
		echo '未知单页';
	}
}
 
/*
*获取指定类型&ID链接URL
*@param $type string 类型
*@param $id int ID
*/
function getUrl($type,$id){
	return !empty($id) ? Url::other($type, $id) : '';
}
 
/*
*获取验证码
*@param $name string 验证码标识
*/
function getCodeUrl($name=''){
	return Url::other('captcha',$name);
}

/*
*匹配正文图片（缩略图）（html）
*@param $data array 文章数据
*@param $len int 图片数量
*@param $isAuto boolean 无图时，是否使用随机图
*/
function thumb_html($data, $len=1, $isAuto=true){
	preg_match_all("|<img[^>]+src=\"([^>\"]+)\"?[^>]*>|is", $data['content'], $img);
	$thumb=[];
	if(isset($img[1]) && !empty($img[1])){
		$max=min(count($img[1]),$len);
		for($i=0; $i<$max; $i++){
			$imgs=$img[1][$i];
			$newimg=dirname($imgs). '/thum-' .basename($imgs);
			$thumb[]='<img src="'.(file_exists(CMSPATH .'/'. $newimg) ? $newimg : $imgs).'" alt="'.$data['title'].'"/>';
		}
	}elseif($isAuto){
		$thumb[]= '<img src="'. TEMPURL .'/images/random/'.rand(1,20).'.jpg" alt="'.$data['title'].'"/>';
	}
	return join('',$thumb);
}